﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Imaging;

namespace howto_make_drawn_cursor
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Fit the background image.
            this.ClientSize = this.BackgroundImage.Size;

            // Draw the cursor image.
            const int wid = 63;
            const int hgt = 63;
            Bitmap bm = new Bitmap(wid, hgt);
            using (Graphics gr = Graphics.FromImage(bm))
            {
                gr.Clear(Color.Transparent);

                int cx = wid / 2;
                int cy = hgt / 2;
                Point[] outer_points =
                {
                    new Point(cx, 0),
                    new Point(2 * cx, cy),
                    new Point(cx, 2 * cy),
                    new Point(0, cy),
                };
                using (SolidBrush br =
                    new SolidBrush(Color.FromArgb(128, 255, 255, 0)))
                {
                    gr.FillPolygon(br, outer_points);
                }
                gr.DrawPolygon(Pens.Red, outer_points);

                Point[] inner_points =
                {
                    new Point(cx, cy - 6),
                    new Point(cx + 6, cy),
                    new Point(cx, cy + 6),
                    new Point(cx - 6, cy),
                };
                gr.FillPolygon(Brushes.LightBlue, inner_points);
                gr.DrawPolygon(Pens.Blue, inner_points);
            }

            // Turn the bitmap into a cursor.
            this.Cursor = new Cursor(bm.GetHicon());
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            this.Text = "(" + e.X.ToString() + ", " + e.Y.ToString() + ")";
        }
    }
}
